<?php

require_once dirname(__FILE__) . '/../../../TestHelper.php';

/**
 * Test class for Setup_Backend_Schema_Field.
 * Generated by PHPUnit on 2008-04-23 at 17:26:20.
 */
class Setup_Backend_Schema_FieldTest extends Setup_Backend_AbstractTest
{
    public function testIsValid()
    {
        $string ="
            <field>
                <name>a</name>
                <type>integer</type>
                <autoincrement>true</autoincrement>
                <unsigned>true</unsigned>
            </field>";

        $field = Setup_Backend_Schema_Field_Factory::factory('Xml', $string);
        $this->assertTrue($field->isValid(), 'Test if a valid field is correctly marked as valid');
        $this->assertTrue($field->isValid(true), 'Test if no Exception is thrown on validating a valid field is correctly marked as valid');
        
        $field->setName(str_pad('A', 23, 'a'));
        $this->asserttrue($field->isValid(), 'Test if the maximum field name length is still valid');
        
        $field->setName(str_pad('A', 24, 'a'));
        $this->assertFalse($field->isValid(), 'Test if a too long field name is invalid');
        
        $this->setExpectedException('Setup_Exception_InvalidSchema');
        $field->isValid(true); //Test if the parameter throwException works as expected
    }
    
    public function testEquals_001()
    {
        $string ="
            <field>
                <name>a</name>
                <type>integer</type>
            </field>";

        $field1 = Setup_Backend_Schema_Field_Factory::factory('Xml', $string);

        $string ="
            <field>
                <name>a</name>
                <type>integer</type>
            </field>";

        $field2 = Setup_Backend_Schema_Field_Factory::factory('Xml', $string);
        
        $this->assertTrue($field1->equals($field2));
    }
    
    public function testEquals_002()
    {
        $string ="
            <field>
                <name>a</name>
                <type>integer</type>
            </field>";

        $field1 = Setup_Backend_Schema_Field_Factory::factory('Xml', $string);

        $string ="
            <field>
                <name>b</name>
                <type>integer</type>
            </field>";

        $field2 = Setup_Backend_Schema_Field_Factory::factory('Xml', $string);
        
        $this->assertFalse($field1->equals($field2));
    }

    public function testEquals_003()
    {
        $string ="
            <field>
                <name>a</name>
                <type>text</type>
            </field>";

        $field1 = Setup_Backend_Schema_Field_Factory::factory('Xml', $string);

        $string ="
            <field>
                <name>a</name>
                <type>integer</type>
            </field>";

        $field2 = Setup_Backend_Schema_Field_Factory::factory('Xml', $string);
        
        $this->assertFalse($field1->equals($field2));
    }
    
    public function testEqualsExistingSchema_001()
    {
        $string ="
            <field>
                <name>a</name>
                <type>integer</type>
            </field>";

        $field1 = Setup_Backend_Schema_Field_Factory::factory('Xml', $string);

        $this->_backend->addCol($this->_table->name, $field1);
        $field2 = $this->_getLastField();
        
        $this->assertTrue($field1->equals($field2));
    }
    
    public function testEqualsExistingSchema_002()
    {
        $string ="
            <field>
                <name>a</name>
                <type>integer</type>
            </field>";

        $field1 = Setup_Backend_Schema_Field_Factory::factory('Xml', $string);
        
        $string ="
            <field>
                <name>a</name>
                <type>integer</type>
                <length>3</length>
            </field>";

        $field2 = Setup_Backend_Schema_Field_Factory::factory('Xml', $string);

        $this->_backend->addCol($this->_table->name, $field2);
        
        $field3 = $this->_getLastField();
        
        $this->assertTrue($field3->equals($field2));
        $this->assertFalse($field3->equals($field1));
        
    }
    
    public function testEqualsExistingSchema_003()
    {
        $string ="
            <field>
                <name>a</name>
                <type>text</type>
            </field>";

        $field1 = Setup_Backend_Schema_Field_Factory::factory('Xml', $string);
        
        $string ="
            <field>
                <name>a</name>
                <type>text</type>
                <length>3</length>
            </field>";

        $field2 = Setup_Backend_Schema_Field_Factory::factory('Xml', $string);

        $this->_backend->addCol($this->_table->name, $field2);
        
        $field3 = $this->_getLastField();
        
        $this->assertTrue($field3->equals($field2));
        $this->assertTrue($field2->equals($field3));
        $this->assertFalse($field3->equals($field1));
        $this->assertFalse($field1->equals($field3));
    }
    
    public function testEqualsExistingSchema_004()
    {
        $string ="
            <field>
                <name>a</name>
                <type>datetime</type>
            </field>";

        $field1 = Setup_Backend_Schema_Field_Factory::factory('Xml', $string);

        $this->_backend->addCol($this->_table->name, $field1);
        
        $field2 = $this->_getLastField();
        
        $this->assertTrue($field1->equals($field2));
        $this->assertTrue($field2->equals($field1));
    }

}
